package ipsk.db.speech;

import ipsk.util.ResourceKey;
import ipsk.util.annotations.TextAreaView;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.ManyToMany;
import javax.persistence.OneToMany;
import javax.persistence.Transient;


@Entity
public class FormConfiguration implements ipsk.beans.form.FormConfiguration{

	
	private int id;
	private Set<Project> speakerFormProjects=new HashSet<Project>(); 
	
	@OneToMany(mappedBy="speakerFormConfiguration")
	public Set<Project> getSpeakerFormProjects() {
		return speakerFormProjects;
	}
	public void setSpeakerFormProjects(Set<Project> speakerFormProjects) {
		this.speakerFormProjects = speakerFormProjects;
	}
	@Id
	@Column(name = "id", unique = true, nullable = false)
    @GeneratedValue(generator="id_gen")
	public int getId() {
		return id;
	}
	public void setId(int id) {
		this.id = id;
	}
	private String displayName;
	public String getDisplayName() {
		return displayName;
	}
	public void setDisplayName(String displayName) {
		this.displayName = displayName;
	}
	private String description;
	
	
	@Column(length=1000)
	@TextAreaView
	public String getDescription() {
		return description;
	}
	public void setDescription(String description) {
		this.description = description;
	}
	private boolean defaultShow=true;
	private String propertyClassId;
	
	public String getPropertyClassId() {
		return propertyClassId;
	}
	public void setPropertyClassId(String propertyClassId) {
		this.propertyClassId = propertyClassId;
	}
	public boolean isDefaultShow() {
		return defaultShow;
	}
	public void setDefaultShow(boolean defaultShow) {
		this.defaultShow = defaultShow;
	}
	@ManyToMany()
//	@JoinTable(
//		        name="form_configuration_input_property_configuration",
//		        joinColumns={@JoinColumn(name="form_configuration_id")},
//		        inverseJoinColumns={@JoinColumn(name="property_configuration_id")}
//		    )
    @ResourceKey("property_configurations")
	public Set<PropertyConfiguration> getInputPropertyConfigurations() {
		return inputPropertyConfigurations;
	}
	public void setInputPropertyConfigurations(
			Set<PropertyConfiguration> inputpropertyConfiguartions) {
		this.inputPropertyConfigurations = inputpropertyConfiguartions;
	}
	private boolean defaultRequired=true;
	public boolean isDefaultRequired() {
		return defaultRequired;
	}
	public void setDefaultRequired(boolean defaultRequired) {
		this.defaultRequired = defaultRequired;
	}
	private Set<PropertyConfiguration> inputPropertyConfigurations;


//	@Override
	@Transient
	public Class<?> getBeanClass() {
		String pcid=getPropertyClassId();
		String pcClassName=pcid.replaceFirst("java:","");
		try {
			return Class.forName(pcClassName);
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		// TODO see Speechrecorder XML class name coding
		return null;
	}
//	@Override
	@Transient
	public List<ipsk.beans.form.PropertyConfiguration> getPropertyConfigurations() {
		Set<PropertyConfiguration> persInputPropCfgs=getInputPropertyConfigurations();
		ArrayList<ipsk.beans.form.PropertyConfiguration> list=new ArrayList<ipsk.beans.form.PropertyConfiguration>();
		
		list.addAll(persInputPropCfgs);
		return list;
	}
	
}
